package application;

import java.awt.Color;
import java.util.ArrayList;
import java.util.List;
import javafx.scene.paint.CycleMethod;
import javafx.scene.paint.LinearGradient;
import javafx.scene.paint.RadialGradient;
import javafx.scene.paint.Stop;
import javafx.scene.shape.Circle;
import javafx.scene.shape.Shape;

public class MoreBalls extends Circle
{
	private double dx;
	private double dy;
	private double radius;
	private double areaWidth;
	private double areaHeight;
	private Color colour;
	public static ArrayList<MoreBalls> balls = new ArrayList<MoreBalls>();
	
	//constructor for making new balls
	public MoreBalls(double radius, double areaWidth, double areaHeight, ArrayList<MoreBalls> balls, Color colour) {
		super();
		this.radius = radius;
		this.areaWidth = areaWidth;
		this.areaHeight = areaHeight;
		this.balls = balls;
		this.colour = colour;
		
		super.setRadius(radius);
		
		super.setCenterX(Math.random() * (areaWidth - this.radius) + 1);
		super.setCenterY(Math.random() * (areaHeight - this.radius) + 1);
		
		dx = Math.random() * 5 + 1;
		dy = Math.random() * 5 + 1;
		
		
		//doesn't work Stop not recognised **look at more
//		RadialGradient gradient = new RadialGradient(0, 0, 0.35, 0.35, 0.5, true, CycleMethod.NO_CYCLE,
//				new Stop(0.0, Color.WHITE), new Stop(1, Color.RED));
		
//		RadialGradient gradient = new RadialGradient(0, 0,
//													0.35, 0.35,
//													0.5,
//													true,
//													CycleMethod.NO_CYCLE,
//													new Stop(0, Color.WHITE),
//													new Stop(1, Color.RED));
//		super.setFill(gradient);

	}
	
	//setting ball movement and wall and ball collision 
	public void move()
	{
		super.setCenterX(super.getCenterX() + dx);
		super.setCenterY(super.getCenterY() + dy);
		
		if (super.getCenterX() <= radius) 
		{
			super.setCenterX(radius);
			dx = - dx;
		}
		if (super.getCenterX() >= areaWidth - radius) 
		{
			super.setCenterX(areaWidth - radius);
			dx = - dx;
		}
		if (super.getCenterY() <= radius) 
		{
			super.setCenterY(radius);
			dy = -dy;
		}
		if (super.getCenterY() >= areaHeight - radius) 
		{
			super.setCenterY(areaHeight - radius);
			dy = -dy;
		}
		
		for (MoreBalls b : balls) 
		{
			if (b != this && b.intersects(super.getLayoutBounds())) 
			{
				double tempx = dx;
				double tempy = dy;
				dx = b.dx;
				dy = b.dy;
				b.dx = tempx;
				b.dy = tempy;
				break;
			}
		}
	}
	
}
